// 132_Sequencer_3xTrigger_3xMovingROI_VCXG.cpp

/*
Windows VS2015 Project Properties

Debug x64
=========
Configuration Properties
C/C++
    General
        Additional Include Directories:
            D:\Baumer\BGAPI290\Components\Dev\C++\Inc;%(AdditionalIncludeDirectories)
Linker
    General
        Additional Library Directories:
            D:\Baumer\BGAPI290\Components\Dev\C++\Lib\x64;%(AdditionalLibraryDirectories)
    Input
        Additional Dependencies:
            bgapi2_genicam.lib;%(AdditionalDependencies)
Build Events
    Post-Build Event
        Command Line:
            copy "D:\Baumer\BGAPI290\Components\Bin\x64"\*.* .\


Release x64
===========
Configuration Properties
C/C++
    General
        Additional Include Directories:
            D:\Baumer\BGAPI290\Components\Dev\C++\Inc;%(AdditionalIncludeDirectories)
    Code Generation
        Runtime Library
            Multi-threaded (/MT)
Linker
    General
        Additional Library Directories:
            D:\Baumer\BGAPI290\Components\Dev\C++\Lib\x64;%(AdditionalLibraryDirectories)
    Input
        Additional Dependencies:
            bgapi2_genicam.lib;%(AdditionalDependencies)
Build Events
    Post-Build Event
        Command Line:
            copy "D:\Baumer\BGAPI290\Components\Bin\x64"\*.* .\

*/


#include <stdio.h>
#include <iostream>
#include <iomanip>
#include "bgapi2_genicam/bgapi2_genicam.hpp"

using namespace BGAPI2;

int main()
{
	//DECLARATIONS OF VARIABLES
	BGAPI2::SystemList *systemList = NULL;
	BGAPI2::System * pSystem = NULL;
	BGAPI2::String sSystemID;

	BGAPI2::InterfaceList *interfaceList = NULL;
	BGAPI2::Interface * pInterface = NULL;
	BGAPI2::String sInterfaceID;

	BGAPI2::DeviceList *deviceList = NULL;
	BGAPI2::Device * pDevice = NULL;
	BGAPI2::String sDeviceID;

	BGAPI2::DataStreamList *datastreamList = NULL;
	BGAPI2::DataStream * pDataStream = NULL;
	BGAPI2::String sDataStreamID;

	BGAPI2::BufferList *bufferList = NULL;
	BGAPI2::Buffer * pBuffer = NULL;
	BGAPI2::String sBufferID;
	int returncode = 0;

	std::cout << std::endl;
	std::cout << "################################################" << std::endl;
	std::cout << "# 132_Sequencer_3xTrigger_3xMovingROI_VCXG.cpp #" << std::endl;
	std::cout << "################################################" << std::endl;
	std::cout << std::endl << std::endl;


	std::cout << "SYSTEM LIST" << std::endl;
	std::cout << "###########" << std::endl << std::endl;

	//COUNTING AVAILABLE SYSTEMS (TL producers) 
	try
	{
		systemList = SystemList::GetInstance();
		systemList->Refresh();
		std::cout << "5.1.2   Detected systems:  " << systemList->size() << std::endl;

		//SYSTEM DEVICE INFORMATION
		for (SystemList::iterator sysIterator = systemList->begin(); sysIterator != systemList->end(); sysIterator++)
		{
			std::cout << "  5.2.1   System Name:     " << sysIterator->second->GetFileName() << std::endl;
			std::cout << "          System Type:     " << sysIterator->second->GetTLType() << std::endl;
			std::cout << "          System Version:  " << sysIterator->second->GetVersion() << std::endl;
			std::cout << "          System PathName: " << sysIterator->second->GetPathName() << std::endl << std::endl;
		}
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}


	//OPEN THE FIRST SYSTEM IN THE LIST WITH A CAMERA CONNECTED
	try
	{
		for (SystemList::iterator sysIterator = systemList->begin(); sysIterator != systemList->end(); sysIterator++)
		{
			std::cout << "SYSTEM" << std::endl;
			std::cout << "######" << std::endl << std::endl;

			try
			{
				sysIterator->second->Open();
				std::cout << "5.1.3   Open next system " << std::endl;
				std::cout << "  5.2.1   System Name:     " << sysIterator->second->GetFileName() << std::endl;
				std::cout << "          System Type:     " << sysIterator->second->GetTLType() << std::endl;
				std::cout << "          System Version:  " << sysIterator->second->GetVersion() << std::endl;
				std::cout << "          System PathName: " << sysIterator->second->GetPathName() << std::endl << std::endl;
				sSystemID = sysIterator->first;
				std::cout << "        Opened system - NodeList Information " << std::endl;
				std::cout << "          GenTL Version:   " << sysIterator->second->GetNode("GenTLVersionMajor")->GetValue() << "." << sysIterator->second->GetNode("GenTLVersionMinor")->GetValue() << std::endl << std::endl;

				std::cout << "INTERFACE LIST" << std::endl;
				std::cout << "##############" << std::endl << std::endl;

				try
				{
					interfaceList = sysIterator->second->GetInterfaces();
					//COUNT AVAILABLE INTERFACES
					interfaceList->Refresh(100); // timeout of 100 msec
					std::cout << "5.1.4   Detected interfaces: " << interfaceList->size() << std::endl;

					//INTERFACE INFORMATION
					for (InterfaceList::iterator ifIterator = interfaceList->begin(); ifIterator != interfaceList->end(); ifIterator++)
					{
						std::cout << "  5.2.2   Interface ID:      " << ifIterator->first << std::endl;
						std::cout << "          Interface Type:    " << ifIterator->second->GetTLType() << std::endl;
						std::cout << "          Interface Name:    " << ifIterator->second->GetDisplayName() << std::endl << std::endl;
					}
				}
				catch (BGAPI2::Exceptions::IException& ex)
				{
					returncode = 0 == returncode ? 1 : returncode;
					std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
					std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
					std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
				}


				std::cout << "INTERFACE" << std::endl;
				std::cout << "#########" << std::endl << std::endl;

				//OPEN THE NEXT INTERFACE IN THE LIST
				try
				{
					for (InterfaceList::iterator ifIterator = interfaceList->begin(); ifIterator != interfaceList->end(); ifIterator++)
					{
						try
						{
							std::cout << "5.1.5   Open interface " << std::endl;
							std::cout << "  5.2.2   Interface ID:      " << ifIterator->first << std::endl;
							std::cout << "          Interface Type:    " << ifIterator->second->GetTLType() << std::endl;
							std::cout << "          Interface Name:    " << ifIterator->second->GetDisplayName() << std::endl;
							ifIterator->second->Open();
							//search for any camera is connetced to this interface
							deviceList = ifIterator->second->GetDevices();
							deviceList->Refresh(100);
							if (deviceList->size() == 0)
							{
								std::cout << "5.1.13   Close interface (" << deviceList->size() << " cameras found) " << std::endl << std::endl;
								ifIterator->second->Close();
							}
							else
							{
								sInterfaceID = ifIterator->first;
								std::cout << "   " << std::endl;
								std::cout << "        Opened interface - NodeList Information " << std::endl;
								if (ifIterator->second->GetTLType() == "GEV")
								{
									bo_int64 iIpAddress = ifIterator->second->GetNode("GevInterfaceSubnetIPAddress")->GetInt();
									std::cout << "          GevInterfaceSubnetIPAddress: " << (iIpAddress >> 24) << "."
										<< ((iIpAddress & 0xffffff) >> 16) << "."
										<< ((iIpAddress & 0xffff) >> 8) << "."
										<< (iIpAddress & 0xff) << std::endl;
									bo_int64 iSubnetMask = ifIterator->second->GetNode("GevInterfaceSubnetMask")->GetInt();
									std::cout << "          GevInterfaceSubnetMask:      " << (iSubnetMask >> 24) << "."
										<< ((iSubnetMask & 0xffffff) >> 16) << "."
										<< ((iSubnetMask & 0xffff) >> 8) << "."
										<< (iSubnetMask & 0xff) << std::endl;
								}
								if (ifIterator->second->GetTLType() == "U3V")
								{
									//std::cout << "          NodeListCount:     " << ifIterator->second->GetNodeList()->GetNodeCount() << std::endl;    
								}
								std::cout << "  " << std::endl;
								break;
							}
						}
						catch (BGAPI2::Exceptions::ResourceInUseException& ex)
						{
							returncode = 0 == returncode ? 1 : returncode;
							std::cout << " Interface " << ifIterator->first << " already opened " << std::endl;
							std::cout << " ResourceInUseException: " << ex.GetErrorDescription() << std::endl;
						}
					}
				}
				catch (BGAPI2::Exceptions::IException& ex)
				{
					returncode = 0 == returncode ? 1 : returncode;
					std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
					std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
					std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
				}


				//if a camera is connected to the system interface then leave the system loop
				if (sInterfaceID != "")
				{
					break;
				}
			}
			catch (BGAPI2::Exceptions::ResourceInUseException& ex)
			{
				returncode = 0 == returncode ? 1 : returncode;
				std::cout << " System " << sysIterator->first << " already opened " << std::endl;
				std::cout << " ResourceInUseException: " << ex.GetErrorDescription() << std::endl;
			}
		}
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	if (sSystemID == "")
	{
		std::cout << " No System found " << std::endl;
		std::cout << std::endl << "End" << std::endl << "Input any number to close the program:";
		int endKey = 0;
		std::cin >> endKey;
		BGAPI2::SystemList::ReleaseInstance();
		return returncode;
	}
	else
	{
		pSystem = (*systemList)[sSystemID];
	}


	if (sInterfaceID == "")
	{
		std::cout << " No camera found " << sInterfaceID << std::endl;
		std::cout << std::endl << "End" << std::endl << "Input any number to close the program:";
		int endKey = 0;
		std::cin >> endKey;
		pSystem->Close();
		BGAPI2::SystemList::ReleaseInstance();
		return returncode;
	}
	else
	{
		pInterface = (*interfaceList)[sInterfaceID];
	}


	std::cout << "DEVICE LIST" << std::endl;
	std::cout << "###########" << std::endl << std::endl;

	try
	{
		//COUNTING AVAILABLE CAMERAS
		deviceList = pInterface->GetDevices();
		deviceList->Refresh(100);
		std::cout << "5.1.6   Detected devices:         " << deviceList->size() << std::endl;

		//DEVICE INFORMATION BEFORE OPENING
		for (DeviceList::iterator devIterator = deviceList->begin(); devIterator != deviceList->end(); devIterator++)
		{
			std::cout << "  5.2.3   Device DeviceID:        " << devIterator->first << std::endl;
			std::cout << "          Device Model:           " << devIterator->second->GetModel() << std::endl;
			std::cout << "          Device SerialNumber:    " << devIterator->second->GetSerialNumber() << std::endl;
			std::cout << "          Device Vendor:          " << devIterator->second->GetVendor() << std::endl;
			std::cout << "          Device TLType:          " << devIterator->second->GetTLType() << std::endl;
			std::cout << "          Device AccessStatus:    " << devIterator->second->GetAccessStatus() << std::endl;
			std::cout << "          Device UserID:          " << devIterator->second->GetDisplayName() << std::endl << std::endl;
		}
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}


	std::cout << "DEVICE" << std::endl;
	std::cout << "######" << std::endl << std::endl;

	//OPEN THE FIRST CAMERA IN THE LIST
	try
	{
		for (DeviceList::iterator devIterator = deviceList->begin(); devIterator != deviceList->end(); devIterator++)
		{
			try
			{
				std::cout << "5.1.7   Open first device " << std::endl;
				std::cout << "          Device DeviceID:        " << devIterator->first << std::endl;
				std::cout << "          Device Model:           " << devIterator->second->GetModel() << std::endl;
				std::cout << "          Device SerialNumber:    " << devIterator->second->GetSerialNumber() << std::endl;
				std::cout << "          Device Vendor:          " << devIterator->second->GetVendor() << std::endl;
				std::cout << "          Device TLType:          " << devIterator->second->GetTLType() << std::endl;
				std::cout << "          Device AccessStatus:    " << devIterator->second->GetAccessStatus() << std::endl;
				std::cout << "          Device UserID:          " << devIterator->second->GetDisplayName() << std::endl << std::endl;
				devIterator->second->Open();
				sDeviceID = devIterator->first;
				std::cout << "        Opened device - RemoteNodeList Information " << std::endl;
				std::cout << "          Device AccessStatus:    " << devIterator->second->GetAccessStatus() << std::endl;

				//SERIAL NUMBER
				if (devIterator->second->GetRemoteNodeList()->GetNodePresent("DeviceSerialNumber"))
					std::cout << "          DeviceSerialNumber:     " << devIterator->second->GetRemoteNode("DeviceSerialNumber")->GetValue() << std::endl;
				else if (devIterator->second->GetRemoteNodeList()->GetNodePresent("DeviceID"))
					std::cout << "          DeviceID (SN):          " << devIterator->second->GetRemoteNode("DeviceID")->GetValue() << std::endl;
				else
					std::cout << "          SerialNumber:           Not Available " << std::endl;

				//DISPLAY DEVICEMANUFACTURERINFO
				if (devIterator->second->GetRemoteNodeList()->GetNodePresent("DeviceManufacturerInfo"))
					std::cout << "          DeviceManufacturerInfo: " << devIterator->second->GetRemoteNode("DeviceManufacturerInfo")->GetValue() << std::endl;


				//DISPLAY DEVICEFIRMWAREVERSION OR DEVICEVERSION
				if (devIterator->second->GetRemoteNodeList()->GetNodePresent("DeviceFirmwareVersion"))
					std::cout << "          DeviceFirmwareVersion:  " << devIterator->second->GetRemoteNode("DeviceFirmwareVersion")->GetValue() << std::endl;
				else if (devIterator->second->GetRemoteNodeList()->GetNodePresent("DeviceVersion"))
					std::cout << "          DeviceVersion:          " << devIterator->second->GetRemoteNode("DeviceVersion")->GetValue() << std::endl;
				else
					std::cout << "          DeviceVersion:          Not Available " << std::endl;

				if (devIterator->second->GetTLType() == "GEV")
				{
					std::cout << "          GevCCP:                 " << devIterator->second->GetRemoteNode("GevCCP")->GetValue() << std::endl;
					std::cout << "          GevCurrentIPAddress:    " << ((devIterator->second->GetRemoteNode("GevCurrentIPAddress")->GetInt() & 0xff000000) >> 24) << "." << ((devIterator->second->GetRemoteNode("GevCurrentIPAddress")->GetInt() & 0x00ff0000) >> 16) << "." << ((devIterator->second->GetRemoteNode("GevCurrentIPAddress")->GetInt() & 0x0000ff00) >> 8) << "." << (devIterator->second->GetRemoteNode("GevCurrentIPAddress")->GetInt() & 0x0000ff) << std::endl;
					std::cout << "          GevCurrentSubnetMask:   " << ((devIterator->second->GetRemoteNode("GevCurrentSubnetMask")->GetInt() & 0xff000000) >> 24) << "." << ((devIterator->second->GetRemoteNode("GevCurrentSubnetMask")->GetInt() & 0x00ff0000) >> 16) << "." << ((devIterator->second->GetRemoteNode("GevCurrentSubnetMask")->GetInt() & 0x0000ff00) >> 8) << "." << (devIterator->second->GetRemoteNode("GevCurrentSubnetMask")->GetInt() & 0x0000ff) << std::endl;
				}
				std::cout << "  " << std::endl;
				break;
			}
			catch (BGAPI2::Exceptions::ResourceInUseException& ex)
			{
				returncode = 0 == returncode ? 1 : returncode;
				std::cout << " Device  " << devIterator->first << " already opened " << std::endl;
				std::cout << " ResourceInUseException: " << ex.GetErrorDescription() << std::endl;
			}
			catch (BGAPI2::Exceptions::AccessDeniedException& ex)
			{
				returncode = 0 == returncode ? 1 : returncode;
				std::cout << " Device  " << devIterator->first << " already opened " << std::endl;
				std::cout << " AccessDeniedException " << ex.GetErrorDescription() << std::endl;
			}
		}
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	if (sDeviceID == "")
	{
		std::cout << " No Device found " << sDeviceID << std::endl;
		std::cout << std::endl << "End" << std::endl << "Input any number to close the program:";
		int endKey = 0;
		std::cin >> endKey;
		pInterface->Close();
		pSystem->Close();
		BGAPI2::SystemList::ReleaseInstance();
		return returncode;
	}
	else
	{
		pDevice = (*deviceList)[sDeviceID];
	}


	std::cout << "DEVICE PARAMETER SETUP" << std::endl;
	std::cout << "######################" << std::endl << std::endl;

	try
	{
		//DEVICE PARAMETER SETUP VCXG
		pDevice->GetRemoteNode("AcquisitionStop")->Execute();
		std::cout << "          AcquisitionStop           : Done" << std::endl;

		if (pDevice->GetRemoteNode("SequencerMode")->GetString() == "On")
		{
			pDevice->GetRemoteNode("SequencerMode")->SetString("Off");
		}
		std::cout << "          SequencerMode             : " << pDevice->GetRemoteNode("SequencerMode")->GetString() << std::endl;

		if (pDevice->GetRemoteNode("SequencerConfigurationMode")->GetString() == "On")
		{
			pDevice->GetRemoteNode("SequencerConfigurationMode")->SetString("Off");
		}
		std::cout << "          SequencerConfigurationMode: " << pDevice->GetRemoteNode("SequencerConfigurationMode")->GetString() << std::endl;
		std::cout << std::endl;

		//LOAD DEFAULT PARAMETERS
		pDevice->GetRemoteNode("UserSetSelector")->SetString("Default");
		std::cout << "          UserSetSelector           : " << pDevice->GetRemoteNode("UserSetSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserSetLoad")->Execute();
		std::cout << "          UserSetLoad               : Done" << std::endl;
		std::cout << std::endl;

		//TRIGGER MODE
		pDevice->GetRemoteNode("TriggerMode")->SetString("On");
		std::cout << "          TriggerMode               : " << pDevice->GetRemoteNode("TriggerMode")->GetString() << std::endl;
		pDevice->GetRemoteNode("TriggerSource")->SetString("Line0");
		std::cout << "          TriggerSource             : " << pDevice->GetRemoteNode("TriggerSource")->GetString() << std::endl;
		pDevice->GetRemoteNode("TriggerActivation")->SetString("RisingEdge");
		std::cout << "          TriggerActivation         : " << pDevice->GetRemoteNode("TriggerActivation")->GetString() << std::endl;
		pDevice->GetRemoteNode("TriggerDelay")->SetDouble(0.0);
		std::cout << "          TriggerDelay              : " << pDevice->GetRemoteNode("TriggerDelay")->GetDouble() << std::endl;
		std::cout << std::endl;

		//LINE0 INPUT
		pDevice->GetRemoteNode("LineSelector")->SetString("Line0");
		std::cout << "          LineSelector              : " << pDevice->GetRemoteNode("LineSelector")->GetString() << std::endl;
		std::cout << "          LineMode                  : " << pDevice->GetRemoteNode("LineMode")->GetString() << std::endl;
		pDevice->GetRemoteNode("LineInverter")->SetBool(false);
		std::cout << "          LineInverter              : " << pDevice->GetRemoteNode("LineInverter")->GetBool() << std::endl;
		pDevice->GetRemoteNode("LineDebouncerHighTimeAbs")->SetDouble(1.0); //1 usec
		std::cout << "          LineDebouncerHighTimeAbs  : " << pDevice->GetRemoteNode("LineDebouncerHighTimeAbs")->GetDouble() << std::endl;
		pDevice->GetRemoteNode("LineDebouncerLowTimeAbs")->SetDouble(1.0); //1 usec
		std::cout << "          LineDebouncerLowTimeAbs   : " << pDevice->GetRemoteNode("LineDebouncerLowTimeAbs")->GetDouble() << std::endl;
		std::cout << std::endl;

		//LINE3 OUTPUT
		pDevice->GetRemoteNode("LineSelector")->SetString("Line3");
		std::cout << "          LineSelector              : " << pDevice->GetRemoteNode("LineSelector")->GetString() << std::endl;
		std::cout << "          LineMode                  : " << pDevice->GetRemoteNode("LineMode")->GetString() << std::endl;
		pDevice->GetRemoteNode("LineInverter")->SetBool(false);
		std::cout << "          LineInverter              : " << pDevice->GetRemoteNode("LineInverter")->GetBool() << std::endl;
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput1");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;
		pDevice->GetRemoteNode("LineSource")->SetString("UserOutput1");
		std::cout << "          LineSource                : " << pDevice->GetRemoteNode("LineSource")->GetString() << std::endl;
		std::cout << std::endl;

		//ROI
		std::cout << "          Width                     : " << pDevice->GetRemoteNode("Width")->GetInt() << std::endl;
		std::cout << "          Height                    : " << pDevice->GetRemoteNode("Height")->GetInt() << std::endl;
		std::cout << "          OffsetX                   : " << pDevice->GetRemoteNode("OffsetX")->GetInt() << std::endl;
		std::cout << "          OffsetY                   : " << pDevice->GetRemoteNode("OffsetY")->GetInt() << std::endl;
		std::cout << std::endl;

		//GAIN (All)
		pDevice->GetRemoteNode("GainSelector")->SetString("All"); // in Sequencer, GainSelector = All is valid only - other settings locks the feature "SequencerConfigurationMode"
		std::cout << "          GainSelector              : " << pDevice->GetRemoteNode("GainSelector")->GetString() << std::endl;
		std::cout << "           Gain                     : " << pDevice->GetRemoteNode("Gain")->GetDouble() << std::endl;
		std::cout << std::endl;

		//CHUNK ALL ON
		if (pDevice->GetRemoteNode("ChunkSelector")->GetEnumNodeList()->GetNodeCount() > 2)
		{
			// ACTIVATE CHUNK
			pDevice->GetRemoteNode("ChunkModeActive")->SetBool(true);
			std::cout << "          ChunkModeActive           : " << pDevice->GetRemoteNode("ChunkModeActive")->GetValue() << std::endl;

			for (bo_uint64 i = 0; i < pDevice->GetRemoteNode("ChunkSelector")->GetEnumNodeList()->GetNodeCount(); i++)
			{
				pDevice->GetRemoteNode("ChunkSelector")->SetString(pDevice->GetRemoteNode("ChunkSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString());

				std::cout << "          ChunkSelector             : " << pDevice->GetRemoteNode("ChunkSelector")->GetValue() << std::endl;
				if (pDevice->GetRemoteNode("ChunkEnable")->GetCurrentAccessMode() == "RW")
				{
					pDevice->GetRemoteNode("ChunkEnable")->SetBool(true);
				}
				std::cout << "           ChunkEnable              : " << pDevice->GetRemoteNode("ChunkEnable")->GetValue() << std::endl;
			}
			std::cout << std::endl;
		}



		//SEQUENCER CONFIGURATION
		//===========================================================================================================================

		if (pDevice->GetRemoteNode("SequencerMode")->GetString() == "On")
		{
			pDevice->GetRemoteNode("SequencerMode")->SetString("Off");
		}
		std::cout << "          SequencerMode             : " << pDevice->GetRemoteNode("SequencerMode")->GetString() << std::endl;



		//LIST OF SEQUENCER CONTROLLED FEATURES
		for (bo_uint64 i = 0; i < pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeCount(); i++)
		{
			pDevice->GetRemoteNode("SequencerFeatureSelector")->SetString(pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString());

			std::cout << "          SequencerFeatureSelector  : " << pDevice->GetRemoteNode("SequencerFeatureSelector")->GetValue() << std::endl;
			if (pDevice->GetRemoteNode("SequencerFeatureEnable")->GetCurrentAccessMode() == "RW")
			{
				pDevice->GetRemoteNode("SequencerFeatureEnable")->SetBool(true);
			}
			std::cout << "           SequencerFeatureEnable   : " << pDevice->GetRemoteNode("SequencerFeatureEnable")->GetValue() << std::endl;
		}
		std::cout << std::endl;




		if (pDevice->GetRemoteNode("SequencerConfigurationMode")->GetString() == "Off")
		{
			pDevice->GetRemoteNode("SequencerConfigurationMode")->SetString("On");
		}
		std::cout << "          SequencerConfigurationMode: " << pDevice->GetRemoteNode("SequencerConfigurationMode")->GetString() << std::endl;
		std::cout << std::endl;


		//SET 0
		pDevice->GetRemoteNode("SequencerSetSelector")->SetInt(0);
		std::cout << "          SequencerSetSelector      : " << pDevice->GetRemoteNode("SequencerSetSelector")->GetInt() << std::endl;
		pDevice->GetRemoteNode("SequencerSetLoad")->Execute();
		std::cout << "          SequencerSetLoad          : Done " << std::endl;

		//LIST OF SEQUENCER FEATURES
		for (bo_uint64 i = 0; i < pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeCount(); i++)
		{
			pDevice->GetRemoteNode("SequencerFeatureSelector")->SetString(pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString());
			if (pDevice->GetRemoteNode("SequencerFeatureEnable")->GetBool() == true)
			{
				std::cout << "           " << std::left << std::setw(25) << pDevice->GetRemoteNode("SequencerFeatureSelector")->GetValue() << std::right << ": ";
				std::cout << pDevice->GetRemoteNode(pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString())->GetValue() << std::endl;
			}
		}

		//TRIGGER MODE 
		pDevice->GetRemoteNode("TriggerMode")->SetString("On");
		std::cout << "          TriggerMode               : " << pDevice->GetRemoteNode("TriggerMode")->GetString() << std::endl;

		//USER OUTPUT
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput1");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput2");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput3");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;

		//COUNTER
		pDevice->GetRemoteNode("CounterSelector")->SetString("Counter1");
		std::cout << "          CounterSelector           : " << pDevice->GetRemoteNode("CounterSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterEventSource")->SetString("Off");
		std::cout << "          CounterEventSource        : " << pDevice->GetRemoteNode("CounterEventSource")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterSelector")->SetString("Counter2");
		std::cout << "          CounterSelector           : " << pDevice->GetRemoteNode("CounterSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterEventSource")->SetString("Off");
		std::cout << "          CounterEventSource        : " << pDevice->GetRemoteNode("CounterEventSource")->GetString() << std::endl;

		//SEQUENCER ROI SET0
		pDevice->GetRemoteNode("OffsetX")->SetInt(0);
		std::cout << "          OffsetX                   : " << pDevice->GetRemoteNode("OffsetX")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetY")->SetInt(0);
		std::cout << "          OffsetY                   : " << pDevice->GetRemoteNode("OffsetY")->GetInt() << std::endl;
		pDevice->GetRemoteNode("Width")->SetInt(pDevice->GetRemoteNode("Width")->GetIntMax() / 2 / pDevice->GetRemoteNode("Width")->GetIntInc() * pDevice->GetRemoteNode("Width")->GetIntInc());
		std::cout << "          Width                     : " << pDevice->GetRemoteNode("Width")->GetInt() << std::endl;
		pDevice->GetRemoteNode("Height")->SetInt(pDevice->GetRemoteNode("Height")->GetIntMax() / 2 / pDevice->GetRemoteNode("Height")->GetIntInc() * pDevice->GetRemoteNode("Height")->GetIntInc());
		std::cout << "          Height                    : " << pDevice->GetRemoteNode("Height")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetX")->SetInt(0);
		std::cout << "          OffsetX                   : " << pDevice->GetRemoteNode("OffsetX")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetY")->SetInt(0);
		std::cout << "          OffsetY                   : " << pDevice->GetRemoteNode("OffsetY")->GetInt() << std::endl;

		//EXPOSURE TIME and GAIN
		pDevice->GetRemoteNode("ExposureTime")->SetDouble(11000.0); // 11 ms
		std::cout << "          ExposureTime              : " << pDevice->GetRemoteNode("ExposureTime")->GetDouble() << std::endl;
		pDevice->GetRemoteNode("Gain")->SetDouble(1.0); // GainSelector = All, 1.0 
		std::cout << "          Gain                      : " << pDevice->GetRemoteNode("Gain")->GetDouble() << std::endl;

		//SEQUENCER PATHS
		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(0);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		pDevice->GetRemoteNode("SequencerTriggerSource")->SetString("ExposureActive");
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;
		pDevice->GetRemoteNode("SequencerTriggerActivation")->SetString("RisingEdge");
		std::cout << "          SequencerTriggerActivation: " << pDevice->GetRemoteNode("SequencerTriggerActivation")->GetString() << std::endl;
		pDevice->GetRemoteNode("SequencerSetNext")->SetInt(1);
		std::cout << "          SequencerSetNext          : " << pDevice->GetRemoteNode("SequencerSetNext")->GetInt() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(1);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(2);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(3);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerSetSave")->Execute();
		std::cout << "          SequencerSetSave          : Done " << std::endl;
		std::cout << std::endl;


		//SET 1
		pDevice->GetRemoteNode("SequencerSetSelector")->SetInt(1);
		std::cout << "          SequencerSetSelector      : " << pDevice->GetRemoteNode("SequencerSetSelector")->GetInt() << std::endl;
		pDevice->GetRemoteNode("SequencerSetLoad")->Execute();
		std::cout << "          SequencerSetLoad          : Done " << std::endl;

		//LIST OF SEQUENCER FEATURES
		for (bo_uint64 i = 0; i < pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeCount(); i++)
		{
			pDevice->GetRemoteNode("SequencerFeatureSelector")->SetString(pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString());
			if (pDevice->GetRemoteNode("SequencerFeatureEnable")->GetBool() == true)
			{
				std::cout << "           " << std::left << std::setw(25) << pDevice->GetRemoteNode("SequencerFeatureSelector")->GetValue() << std::right << ": ";
				std::cout << pDevice->GetRemoteNode(pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString())->GetValue() << std::endl;
			}
		}

		//TRIGGER MODE 
		pDevice->GetRemoteNode("TriggerMode")->SetString("On");
		std::cout << "          TriggerMode               : " << pDevice->GetRemoteNode("TriggerMode")->GetString() << std::endl;

		//USER OUTPUT
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput1");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput2");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput3");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;

		//COUNTER
		pDevice->GetRemoteNode("CounterSelector")->SetString("Counter1");
		std::cout << "          CounterSelector           : " << pDevice->GetRemoteNode("CounterSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterEventSource")->SetString("Off");
		std::cout << "          CounterEventSource        : " << pDevice->GetRemoteNode("CounterEventSource")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterSelector")->SetString("Counter2");
		std::cout << "          CounterSelector           : " << pDevice->GetRemoteNode("CounterSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterEventSource")->SetString("Off");
		std::cout << "          CounterEventSource        : " << pDevice->GetRemoteNode("CounterEventSource")->GetString() << std::endl;

		//SEQUENCER ROI
		pDevice->GetRemoteNode("OffsetX")->SetInt(0);
		std::cout << "          OffsetX                   : " << pDevice->GetRemoteNode("OffsetX")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetY")->SetInt(0);
		std::cout << "          OffsetY                   : " << pDevice->GetRemoteNode("OffsetY")->GetInt() << std::endl;
		pDevice->GetRemoteNode("Width")->SetInt(pDevice->GetRemoteNode("Width")->GetIntMax() / 2 / pDevice->GetRemoteNode("Width")->GetIntInc() * pDevice->GetRemoteNode("Width")->GetIntInc());
		std::cout << "          Width                     : " << pDevice->GetRemoteNode("Width")->GetInt() << std::endl;
		pDevice->GetRemoteNode("Height")->SetInt(pDevice->GetRemoteNode("Height")->GetIntMax() / 2 / pDevice->GetRemoteNode("Height")->GetIntInc() * pDevice->GetRemoteNode("Height")->GetIntInc());
		std::cout << "          Height                    : " << pDevice->GetRemoteNode("Height")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetX")->SetInt(pDevice->GetRemoteNode("OffsetX")->GetIntMax() / 2 / pDevice->GetRemoteNode("OffsetX")->GetIntInc() * pDevice->GetRemoteNode("OffsetX")->GetIntInc());
		std::cout << "          OffsetX                   : " << pDevice->GetRemoteNode("OffsetX")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetY")->SetInt(pDevice->GetRemoteNode("OffsetY")->GetIntMax() / 2 / pDevice->GetRemoteNode("OffsetY")->GetIntInc() * pDevice->GetRemoteNode("OffsetY")->GetIntInc());
		std::cout << "          OffsetY                   : " << pDevice->GetRemoteNode("OffsetY")->GetInt() << std::endl;

		//EXPOSURE TIME and GAIN 
		pDevice->GetRemoteNode("ExposureTime")->SetDouble(12000.0); // 12 ms
		std::cout << "          ExposureTime              : " << pDevice->GetRemoteNode("ExposureTime")->GetDouble() << std::endl;
		pDevice->GetRemoteNode("Gain")->SetDouble(1.0); // GainSelector = All, 1.0 
		std::cout << "          Gain                      : " << pDevice->GetRemoteNode("Gain")->GetDouble() << std::endl;

		//SEQUENCER PATHS
		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(0);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		pDevice->GetRemoteNode("SequencerTriggerSource")->SetString("ExposureActive");
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;
		pDevice->GetRemoteNode("SequencerTriggerActivation")->SetString("RisingEdge");
		std::cout << "          SequencerTriggerActivation: " << pDevice->GetRemoteNode("SequencerTriggerActivation")->GetString() << std::endl;
		pDevice->GetRemoteNode("SequencerSetNext")->SetInt(2);
		std::cout << "          SequencerSetNext          : " << pDevice->GetRemoteNode("SequencerSetNext")->GetInt() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(1);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(2);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(3);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerSetSave")->Execute();
		std::cout << "          SequencerSetSave          : Done " << std::endl;
		std::cout << std::endl;


		//SET 2
		pDevice->GetRemoteNode("SequencerSetSelector")->SetInt(2);
		std::cout << "          SequencerSetSelector      : " << pDevice->GetRemoteNode("SequencerSetSelector")->GetInt() << std::endl;
		pDevice->GetRemoteNode("SequencerSetLoad")->Execute();
		std::cout << "          SequencerSetLoad          : Done " << std::endl;

		//LIST OF SEQUENCER FEATURES
		for (bo_uint64 i = 0; i < pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeCount(); i++)
		{
			pDevice->GetRemoteNode("SequencerFeatureSelector")->SetString(pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString());
			if (pDevice->GetRemoteNode("SequencerFeatureEnable")->GetBool() == true)
			{
				std::cout << "           " << std::left << std::setw(25) << pDevice->GetRemoteNode("SequencerFeatureSelector")->GetValue() << std::right << ": ";
				std::cout << pDevice->GetRemoteNode(pDevice->GetRemoteNode("SequencerFeatureSelector")->GetEnumNodeList()->GetNodeByIndex(i)->GetString())->GetValue() << std::endl;
			}
		}

		//TRIGGER MODE 
		pDevice->GetRemoteNode("TriggerMode")->SetString("On");
		std::cout << "          TriggerMode               : " << pDevice->GetRemoteNode("TriggerMode")->GetString() << std::endl;

		//USER OUTPUT
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput1");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput2");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;
		pDevice->GetRemoteNode("UserOutputSelector")->SetString("UserOutput3");
		std::cout << "          UserOutputSelector        : " << pDevice->GetRemoteNode("UserOutputSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("UserOutputValue")->SetBool(false);
		std::cout << "          UserOutputValue           : " << pDevice->GetRemoteNode("UserOutputValue")->GetBool() << std::endl;

		//COUNTER
		pDevice->GetRemoteNode("CounterSelector")->SetString("Counter1");
		std::cout << "          CounterSelector           : " << pDevice->GetRemoteNode("CounterSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterEventSource")->SetString("Off");
		std::cout << "          CounterEventSource        : " << pDevice->GetRemoteNode("CounterEventSource")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterSelector")->SetString("Counter2");
		std::cout << "          CounterSelector           : " << pDevice->GetRemoteNode("CounterSelector")->GetString() << std::endl;
		pDevice->GetRemoteNode("CounterEventSource")->SetString("Off");
		std::cout << "          CounterEventSource        : " << pDevice->GetRemoteNode("CounterEventSource")->GetString() << std::endl;

		//SEQUENCER ROI
		pDevice->GetRemoteNode("OffsetX")->SetInt(0);
		std::cout << "          OffsetX                   : " << pDevice->GetRemoteNode("OffsetX")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetY")->SetInt(0);
		std::cout << "          OffsetY                   : " << pDevice->GetRemoteNode("OffsetY")->GetInt() << std::endl;
		pDevice->GetRemoteNode("Width")->SetInt(pDevice->GetRemoteNode("Width")->GetIntMax() / 2 / pDevice->GetRemoteNode("Width")->GetIntInc() * pDevice->GetRemoteNode("Width")->GetIntInc());
		std::cout << "          Width                     : " << pDevice->GetRemoteNode("Width")->GetInt() << std::endl;
		pDevice->GetRemoteNode("Height")->SetInt(pDevice->GetRemoteNode("Height")->GetIntMax() / 2 / pDevice->GetRemoteNode("Height")->GetIntInc() * pDevice->GetRemoteNode("Height")->GetIntInc());
		std::cout << "          Height                    : " << pDevice->GetRemoteNode("Height")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetX")->SetInt(pDevice->GetRemoteNode("OffsetX")->GetIntMax());
		std::cout << "          OffsetX                   : " << pDevice->GetRemoteNode("OffsetX")->GetInt() << std::endl;
		pDevice->GetRemoteNode("OffsetY")->SetInt(pDevice->GetRemoteNode("OffsetY")->GetIntMax());
		std::cout << "          OffsetY                   : " << pDevice->GetRemoteNode("OffsetY")->GetInt() << std::endl;

		//EXPOSURE TIME and GAIN 
		pDevice->GetRemoteNode("ExposureTime")->SetDouble(13000.0); // 13 ms
		std::cout << "          ExposureTime              : " << pDevice->GetRemoteNode("ExposureTime")->GetDouble() << std::endl;
		pDevice->GetRemoteNode("Gain")->SetDouble(1.0); // GainSelector = All, 1.0 
		std::cout << "          Gain                      : " << pDevice->GetRemoteNode("Gain")->GetDouble() << std::endl;

		//SEQUENCER PATHS
		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(0);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		pDevice->GetRemoteNode("SequencerTriggerSource")->SetString("ExposureActive");
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;
		pDevice->GetRemoteNode("SequencerTriggerActivation")->SetString("RisingEdge");
		std::cout << "          SequencerTriggerActivation: " << pDevice->GetRemoteNode("SequencerTriggerActivation")->GetString() << std::endl;
		pDevice->GetRemoteNode("SequencerSetNext")->SetInt(0);
		std::cout << "          SequencerSetNext          : " << pDevice->GetRemoteNode("SequencerSetNext")->GetInt() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(1);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(2);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerPathSelector")->SetInt(3);
		std::cout << "          SequencerPathSelector     : " << pDevice->GetRemoteNode("SequencerPathSelector")->GetInt() << std::endl;
		std::cout << "          SequencerTriggerSource    : " << pDevice->GetRemoteNode("SequencerTriggerSource")->GetString() << std::endl;

		pDevice->GetRemoteNode("SequencerSetSave")->Execute();
		std::cout << "          SequencerSetSave          : Done " << std::endl;
		std::cout << std::endl;

		//START SET
		pDevice->GetRemoteNode("SequencerSetStart")->SetInt(0);
		std::cout << "          SequencerSetStart         : " << pDevice->GetRemoteNode("SequencerSetStart")->GetInt() << std::endl;
		pDevice->GetRemoteNode("SequencerConfigurationMode")->SetString("Off");
		std::cout << "          SequencerConfigurationMode: " << pDevice->GetRemoteNode("SequencerConfigurationMode")->GetString() << std::endl;
		std::cout << std::endl;
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}


	std::cout << "DATA STREAM LIST" << std::endl;
	std::cout << "################" << std::endl << std::endl;

	try
	{
		//COUNTING AVAILABLE DATASTREAMS
		datastreamList = pDevice->GetDataStreams();
		datastreamList->Refresh();
		std::cout << "5.1.8   Detected datastreams:     " << datastreamList->size() << std::endl;

		//DATASTREAM INFORMATION BEFORE OPENING
		for (DataStreamList::iterator dstIterator = datastreamList->begin(); dstIterator != datastreamList->end(); dstIterator++)
		{
			std::cout << "  5.2.4   DataStream ID:          " << dstIterator->first << std::endl << std::endl;
		}
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}


	std::cout << "DATA STREAM" << std::endl;
	std::cout << "###########" << std::endl << std::endl;

	//OPEN THE FIRST DATASTREAM IN THE LIST
	try
	{
		for (DataStreamList::iterator dstIterator = datastreamList->begin(); dstIterator != datastreamList->end(); dstIterator++)
		{
			std::cout << "5.1.9   Open first datastream " << std::endl;
			std::cout << "          DataStream ID:          " << dstIterator->first << std::endl << std::endl;
			dstIterator->second->Open();
			sDataStreamID = dstIterator->first;
			std::cout << "        Opened datastream - NodeList Information " << std::endl;
			std::cout << "          StreamAnnounceBufferMinimum:  " << dstIterator->second->GetNode("StreamAnnounceBufferMinimum")->GetValue() << std::endl;
			if (dstIterator->second->GetTLType() == "GEV")
			{
				std::cout << "          StreamDriverModel:            " << dstIterator->second->GetNode("StreamDriverModel")->GetValue() << std::endl;
			}
			std::cout << "  " << std::endl;
			break;
		}
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	if (sDataStreamID == "")
	{
		std::cout << " No DataStream found " << sDataStreamID << std::endl;
		std::cout << std::endl << "End" << std::endl << "Input any number to close the program:";
		int endKey = 0;
		std::cin >> endKey;
		pDevice->Close();
		pInterface->Close();
		pSystem->Close();
		BGAPI2::SystemList::ReleaseInstance();
		return returncode;
	}
	else
	{
		pDataStream = (*datastreamList)[sDataStreamID];
	}


	std::cout << "BUFFER LIST" << std::endl;
	std::cout << "###########" << std::endl << std::endl;

	try
	{
		//BufferList
		bufferList = pDataStream->GetBufferList();

		// 4 buffers using internal buffer mode
		for (int i = 0; i<4; i++)
		{
			pBuffer = new BGAPI2::Buffer();
			bufferList->Add(pBuffer);
		}
		std::cout << "5.1.10   Announced buffers:       " << bufferList->GetAnnouncedCount() << " using " << pBuffer->GetMemSize() * bufferList->GetAnnouncedCount() << " [bytes]" << std::endl;
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	try
	{
		for (BufferList::iterator bufIterator = bufferList->begin(); bufIterator != bufferList->end(); bufIterator++)
		{
			bufIterator->second->QueueBuffer();
		}
		std::cout << "5.1.11   Queued buffers:          " << bufferList->GetQueuedCount() << std::endl;
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}
	std::cout << " " << std::endl;


	std::cout << "CAMERA START" << std::endl;
	std::cout << "############" << std::endl << std::endl;

	//START DataStream acquisition
	try
	{
		pDataStream->StartAcquisitionContinuous();
		std::cout << "5.1.12   DataStream started " << std::endl;
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	//START CAMERA
	try
	{
		//SEQUENCER ON
		std::cout << std::endl;
		pDevice->GetRemoteNode("SequencerMode")->SetString("On");
		std::cout << "          SequencerMode             : " << pDevice->GetRemoteNode("SequencerMode")->GetString() << std::endl;
		std::cout << std::endl;
		std::cout << "5.1.12   " << pDevice->GetModel() << " started " << std::endl;
		pDevice->GetRemoteNode("AcquisitionStart")->Execute();
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	//CAPTURE 12 IMAGES
	std::cout << " " << std::endl;
	std::cout << "CAPTURE 12 IMAGES BY IMAGE POLLING" << std::endl;
	std::cout << "##################################" << std::endl << std::endl;

	BGAPI2::Buffer * pBufferFilled = NULL;
	try
	{
		std::cout << "----Wait for hardware triggers at Line0----" << std::endl;
		std::cout << std::endl;

		for (int i = 0; i < 12; i++)
		{
			pBufferFilled = pDataStream->GetFilledBuffer(3000); //timeout 3000 msec
			if (pBufferFilled == NULL)
			{
				std::cout << "Error: Buffer Timeout after 3000 msec" << std::endl;
			}
			else if (pBufferFilled->GetIsIncomplete() == true)
			{
				std::cout << "Error: Image is incomplete" << std::endl;
				// queue buffer again
				pBufferFilled->QueueBuffer();
			}
			else
			{
				std::cout << "  Image " << std::setw(4) << pBufferFilled->GetFrameID();
				std::cout << "  ChunkExposureTime " << std::setw(8) << pBufferFilled->GetChunkNodeTree()->GetNode("ChunkExposureTime")->GetDouble();
				std::cout << "  ChunkTimestamp " << std::setw(16) << pBufferFilled->GetChunkNodeTree()->GetNode("ChunkTimestamp")->GetInt();
				std::cout << "  Width " << std::setw(6) << pBufferFilled->GetWidth();
				std::cout << "  Height " << std::setw(6) << pBufferFilled->GetHeight();
				std::cout << "  OffsetX " << std::setw(6) << pBufferFilled->GetXOffset();
				std::cout << "  OffsetY " << std::setw(6) << pBufferFilled->GetYOffset();
				std::cout << std::endl;

				// queue buffer again
				pBufferFilled->QueueBuffer();
			}
		}
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}
	std::cout << " " << std::endl;


	std::cout << "CAMERA STOP" << std::endl;
	std::cout << "###########" << std::endl << std::endl;

	//STOP CAMERA
	try
	{
		//SEQUENCER OFF
		pDevice->GetRemoteNode("SequencerMode")->SetString("Off");
		std::cout << "          SequencerMode             : " << pDevice->GetRemoteNode("SequencerMode")->GetString() << std::endl;
		std::cout << std::endl;

		//SEARCH FOR 'AcquisitionAbort'
		if (pDevice->GetRemoteNodeList()->GetNodePresent("AcquisitionAbort"))
		{
			pDevice->GetRemoteNode("AcquisitionAbort")->Execute();
			std::cout << "5.1.12   " << pDevice->GetModel() << " aborted " << std::endl;
		}

		pDevice->GetRemoteNode("AcquisitionStop")->Execute();
		std::cout << "5.1.12   " << pDevice->GetModel() << " stopped " << std::endl;
		std::cout << std::endl;

		BGAPI2::String sExposureNodeName = "";
		if (pDevice->GetRemoteNodeList()->GetNodePresent("ExposureTime")) {
			sExposureNodeName = "ExposureTime";
		}
		else if (pDevice->GetRemoteNodeList()->GetNodePresent("ExposureTimeAbs")) {
			sExposureNodeName = "ExposureTimeAbs";
		}
		std::cout << "         ExposureTime:                     " << std::fixed << std::setprecision(0) << pDevice->GetRemoteNode(sExposureNodeName)->GetDouble() << " [" << pDevice->GetRemoteNode(sExposureNodeName)->GetUnit() << "]" << std::endl;
		if (pDevice->GetTLType() == "GEV")
		{
			if (pDevice->GetRemoteNodeList()->GetNodePresent("DeviceStreamChannelPacketSize"))
				std::cout << "         DeviceStreamChannelPacketSize:    " << pDevice->GetRemoteNode("DeviceStreamChannelPacketSize")->GetInt() << " [bytes]" << std::endl;
			else
				std::cout << "         GevSCPSPacketSize:                " << pDevice->GetRemoteNode("GevSCPSPacketSize")->GetInt() << " [bytes]" << std::endl;
			std::cout << "         GevSCPD (PacketDelay):            " << pDevice->GetRemoteNode("GevSCPD")->GetInt() << " [tics]" << std::endl;
		}
		std::cout << std::endl;
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	//STOP DataStream acquisition
	try
	{
		if (pDataStream->GetTLType() == "GEV")
		{
			//DataStream Statistic
			std::cout << "         DataStream Statistics " << std::endl;
			std::cout << "           DataBlockComplete:              " << pDataStream->GetNodeList()->GetNode("DataBlockComplete")->GetInt() << std::endl;
			std::cout << "           DataBlockInComplete:            " << pDataStream->GetNodeList()->GetNode("DataBlockInComplete")->GetInt() << std::endl;
			std::cout << "           DataBlockMissing:               " << pDataStream->GetNodeList()->GetNode("DataBlockMissing")->GetInt() << std::endl;
			std::cout << "           PacketResendRequestSingle:      " << pDataStream->GetNodeList()->GetNode("PacketResendRequestSingle")->GetInt() << std::endl;
			std::cout << "           PacketResendRequestRange:       " << pDataStream->GetNodeList()->GetNode("PacketResendRequestRange")->GetInt() << std::endl;
			std::cout << "           PacketResendReceive:            " << pDataStream->GetNodeList()->GetNode("PacketResendReceive")->GetInt() << std::endl;
			std::cout << "           DataBlockDroppedBufferUnderrun: " << pDataStream->GetNodeList()->GetNode("DataBlockDroppedBufferUnderrun")->GetInt() << std::endl;
			std::cout << "           Bitrate:                        " << std::fixed << std::setprecision(1) << pDataStream->GetNodeList()->GetNode("Bitrate")->GetDouble() << " " << pDataStream->GetNodeList()->GetNode("Bitrate")->GetUnit() << std::endl;
			std::cout << "           Throughput:                     " << std::fixed << std::setprecision(1) << pDataStream->GetNodeList()->GetNode("Throughput")->GetDouble() << " " << pDataStream->GetNodeList()->GetNode("Throughput")->GetUnit() << std::endl;
			std::cout << std::endl;
		}
		if (pDataStream->GetTLType() == "U3V")
		{
			//DataStream Statistic
			std::cout << "         DataStream Statistics " << std::endl;
			std::cout << "           GoodFrames:                     " << pDataStream->GetNodeList()->GetNode("GoodFrames")->GetInt() << std::endl;
			std::cout << "           CorruptedFrames:                " << pDataStream->GetNodeList()->GetNode("CorruptedFrames")->GetInt() << std::endl;
			std::cout << "           LostFrames:                     " << pDataStream->GetNodeList()->GetNode("LostFrames")->GetInt() << std::endl;
			std::cout << std::endl;
		}

		//BufferList Information
		std::cout << "         BufferList Information " << std::endl;
		std::cout << "           DeliveredCount:                 " << bufferList->GetDeliveredCount() << std::endl;
		std::cout << "           UnderrunCount:                  " << bufferList->GetUnderrunCount() << std::endl;
		std::cout << std::endl;

		pDataStream->StopAcquisition();
		std::cout << "5.1.12   DataStream stopped " << std::endl;
		bufferList->DiscardAllBuffers();
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}
	std::cout << std::endl;


	std::cout << "RELEASE" << std::endl;
	std::cout << "#######" << std::endl << std::endl;

	//Release buffers
	std::cout << "5.1.13   Releasing the resources " << std::endl;
	try
	{
		while (bufferList->size() > 0)
		{
			pBuffer = bufferList->begin()->second;
			bufferList->RevokeBuffer(pBuffer);
			delete pBuffer;
		}
		std::cout << "         buffers after revoke:             " << bufferList->size() << std::endl;

		pDataStream->Close();
		pDevice->Close();
		pInterface->Close();
		pSystem->Close();
		BGAPI2::SystemList::ReleaseInstance();
	}
	catch (BGAPI2::Exceptions::IException& ex)
	{
		returncode = 0 == returncode ? 1 : returncode;
		std::cout << "ExceptionType:    " << ex.GetType() << std::endl;
		std::cout << "ErrorDescription: " << ex.GetErrorDescription() << std::endl;
		std::cout << "in function:      " << ex.GetFunctionName() << std::endl;
	}

	std::cout << std::endl;
	std::cout << "End" << std::endl << std::endl;

	std::cout << "Input any number to close the program:";
	int endKey = 0;
	std::cin >> endKey;
	return returncode;
}